//---------------------------------------------------------------------------

#include <vcl.h>
#include <tchar.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "Main.h"
#include "nMail.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;

enum {
	serviceGmail,
	serviceOffice365,
};

// FR[h擾 URI
const TCHAR *AuthUri[] = {
	_T("https://accounts.google.com/o/oauth2/auth"),
	_T("https://login.microsoftonline.com/%s/oauth2/v2.0/authorize")
};

// XR[v
const TCHAR *AuthScope[] = {
	_T("https://mail.google.com/"),
	_T("offline_access https://outlook.office.com/SMTP.Send https://outlook.office.com/POP.AccessAsUser.All https://outlook.office.com/IMAP.AccessAsUser.All")
};

// ̑̃p[^
const TCHAR *AuthParam[] = {
	_T("access_type=offline"),
	_T("")
};

// g[N擾 URI
const TCHAR *TokenUri[] = {
	_T("https://accounts.google.com/o/oauth2/token"),
	_T("https://login.microsoftonline.com/%s/oauth2/v2.0/token")
};

// POP3 T[o[
const TCHAR *Pop3Host[] = {
	_T("pop.gmail.com"),
	_T("Outlook.office365.com")
};

// IMAP4 T[o[
const TCHAR *Imap4Host[] = {
	_T("imap4.gmail.com"),
	_T("Outlook.office365.com")
};

// SMTP T[o[
const TCHAR *SmtpHost[] = {
	_T("smtp.gmail.com"),
	_T("Smtp.office365.com")
};

// FR[h擾 HTML
const TCHAR *ResponseOk = _T("<html><head><meta charset=\"utf-8\"><title>擾</title></head><body>FR[h̎擾</body></html>");
const TCHAR *ResponseError = _T("<html><head><meta charset=\"utf-8\"><title>擾s</title></head><body>FR[h擾G[</body></html>");

#define	TEMP_MAX		10000
#define	HEADER_MAX		8000
#define	BODY_MAX		100000
#define	STATE_LENGTH	16

#define OPTION_TYPE             "TYPE"
#define OPTION_SECTION          "OPTION"
#define OPTION_CLIENT_ID        "CLIENT_ID"
#define OPTION_CLIENT_SECRET    "CLIENT_SECRET"
#define OPTION_TENANT_ID        "TENANT_ID"
#define OPTION_REDIRECT_URI     "REDIRECT_URI"
#define OPTION_REFRESH_TOKEN    "REFRESH_TOKEN"
#define OPTION_ACCESS_TOKEN     "ACESS_TOKEN"
#define OPTION_MAIL_ADDRESS     "MAIL_ADDRESS"

//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	NMailEndWinSock();

	WriteIni();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::FormCreate(TObject *Sender)
{
	AuthSocket = INVALID_SOCKET;

	// Winsock 
	NMailInitializeWinSock();
	NMailSetOption(NMAIL_OPTION_HEADER_MAX, HEADER_MAX);
	NMailSetOption(NMAIL_OPTION_BODY_MAX, BODY_MAX);

	ReadIni();

	CheckEnableControl();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonGetRefreshClick(TObject *Sender)
{
	if(AuthSocket == INVALID_SOCKET) {
		EditRefreshToken->Text = _T("");
		EditAccessToken->Text = _T("");
		// _CNgT[o[Jn
		AuthSocket = NMailOAuth2StartRedirectServer(EditRedirectUri->Text.c_str(), ResponseOk, ResponseError, Handle, WM_GET_CODE, 0);
		if(AuthSocket != INVALID_SOCKET) {
			TCHAR state[TEMP_MAX];
			// Xe[g쐬
			NMailMakeRandomString(state, STATE_LENGTH, 0);
			AuthState = state;
			// FR[h擾 URI Ăяo
			// uEUNďʂo
			NMailOAuth2RequestAuthorize(GetAuthUri().c_str(), EditClientId->Text.c_str(), EditRedirectUri->Text.c_str(), AuthScope[ComboBoxService->ItemIndex], AuthState.c_str(), NULL, AuthParam[ComboBoxService->ItemIndex], 0);
		}
	} else {
		// _CNgT[o[I
		NMailOAuth2EndRedirectServer(AuthSocket);
		AuthSocket = INVALID_SOCKET;
	}
	CheckEnableControl();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ComboBoxServiceChange(TObject *Sender)
{
	CheckEnableControl();
}
//---------------------------------------------------------------------------


void TFormMain::ReadIni()
{
	TFileName IniFileName;
	TIniFile *IniFile;

	IniFileName = ChangeFileExt(Application->ExeName, ".INI");
	IniFile = new TIniFile(IniFileName);
	try {
		ComboBoxService->ItemIndex = IniFile->ReadInteger(OPTION_SECTION, OPTION_TYPE, serviceGmail);
		EditClientId->Text = IniFile->ReadString(OPTION_SECTION, OPTION_CLIENT_ID, "");
		EditClientSecret->Text = IniFile->ReadString(OPTION_SECTION, OPTION_CLIENT_SECRET, "");
		EditTenantId->Text = IniFile->ReadString(OPTION_SECTION, OPTION_TENANT_ID, "");
		EditRedirectUri->Text = IniFile->ReadString(OPTION_SECTION, OPTION_REDIRECT_URI, "");
		EditRefreshToken->Text = IniFile->ReadString(OPTION_SECTION, OPTION_REFRESH_TOKEN, "");
		EditAccessToken->Text = IniFile->ReadString(OPTION_SECTION, OPTION_ACCESS_TOKEN, "");
		EditMailAddress->Text = IniFile->ReadString(OPTION_SECTION, OPTION_MAIL_ADDRESS, "");
	}
	catch ( ... ) {
		delete IniFile;
	}
	delete IniFile;
}

void TFormMain::CheckEnableControl()
{
	EditTenantId->Enabled = (ComboBoxService->ItemIndex == serviceOffice365);
	if(AuthSocket == INVALID_SOCKET) {
		ButtonGetRefresh->Caption = _T("tbVg[N擾");
		ButtonGetAccess->Enabled = !EditRefreshToken->Text.IsEmpty();
	} else {
		ButtonGetRefresh->Caption = _T("~");
	}
	LabelAuthUri->Caption = GetAuthUri();
	LabelTokenUri->Caption = GetTokenUri();
}

void TFormMain::WriteIni()
{
	TFileName IniFileName;
	TIniFile *IniFile;

	IniFileName = ChangeFileExt(Application->ExeName, ".INI");
	IniFile = new TIniFile(IniFileName);
	try {
		IniFile->WriteInteger(OPTION_SECTION, OPTION_TYPE, ComboBoxService->ItemIndex);
		IniFile->WriteString(OPTION_SECTION, OPTION_CLIENT_ID, EditClientId->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_CLIENT_SECRET, EditClientSecret->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_TENANT_ID, EditTenantId->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_REDIRECT_URI, EditRedirectUri->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_REFRESH_TOKEN, EditRefreshToken->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_ACCESS_TOKEN, EditAccessToken->Text);
		IniFile->WriteString(OPTION_SECTION, OPTION_MAIL_ADDRESS, EditMailAddress->Text);
	}
	catch (...) {
		delete IniFile;
	}
	delete IniFile;
}

String TFormMain::GetAuthUri()
{
	if(ComboBoxService->ItemIndex == serviceOffice365) {
		// Office365 ̏ꍇ URI Ƀeig ID ܂܂
		return String().sprintf(AuthUri[ComboBoxService->ItemIndex], EditTenantId->Text.IsEmpty() ? _T("") : EditTenantId->Text.c_str());
	}
	return AuthUri[ComboBoxService->ItemIndex];
}

String TFormMain::GetTokenUri()
{
	if(ComboBoxService->ItemIndex == serviceOffice365) {
		// Office365 ̏ꍇ URI Ƀeig ID ܂܂
		return String().sprintf(TokenUri[ComboBoxService->ItemIndex], EditTenantId->Text.IsEmpty() ? _T("") : EditTenantId->Text.c_str());
	}
	return TokenUri[ComboBoxService->ItemIndex];
}

void __fastcall TFormMain::EditTenantIdChange(TObject *Sender)
{
	CheckEnableControl();
}

void __fastcall TFormMain::WMGetCode(TMessage &msg)
{
	int result;
	TCHAR code[TEMP_MAX], state[TEMP_MAX], json[TEMP_MAX], token[TEMP_MAX];

	// FR[hƃXe[g擾
	result = NMailOAuth2GetAuthorizeCode(AuthSocket, code, TEMP_MAX, state, TEMP_MAX);
	// _CNgT[o[I
	NMailOAuth2EndRedirectServer(AuthSocket);
	AuthSocket = INVALID_SOCKET;
	if(result != NMAIL_SUCCESS) {
		MessageDlg(_T("tbVg[N̎擾Ɏs܂B\r\n") + String(code) + String(state), mtError, TMsgDlgButtons() << mbOK, 0);
	} else if(AuthState != state) {
		// CSRF ΍
		MessageDlg(_T("Xe[gقȂ܂B"), mtError, TMsgDlgButtons() << mbOK, 0);
	} else {
		// 擾FR[hgătbVg[N擾
		if((result = NMailOAuth2GetRefreshToken(GetTokenUri().c_str(), EditClientId->Text.c_str(), EditClientSecret->Text.c_str(), EditRedirectUri->Text.c_str(), code, NULL, NULL, NULL, json, TEMP_MAX, 0)) == NMAIL_SUCCESS) {
			if((result = NMailJsonGetValue(json, _T("refresh_token"), token, TEMP_MAX, 0)) == NMAIL_SUCCESS) {
				EditRefreshToken->Text = token;
				Clipboard()->AsText = EditRefreshToken->Text;
				WriteIni();
			}
			if(NMailJsonGetValue(json, _T("access_token"), token, TEMP_MAX, 0) == NMAIL_SUCCESS) {
				EditAccessToken->Text = token;
			}
		}
		if(result == NMAIL_ERROR_JSON_NO_VALUE) {
			MessageDlg(_T("tbVg[N̎擾Ɏs܂B\nAJEg烍OAEgAēxsĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		} else if(result != NMAIL_SUCCESS) {
			MessageDlg(_T("tbVg[N̎擾Ɏs܂B"), mtError, TMsgDlgButtons() << mbOK, 0);
		}
	}
	CheckEnableControl();
}

//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonGetAccessClick(TObject *Sender)
{
	int result;
	TCHAR json[TEMP_MAX], token[TEMP_MAX];

	// tbVg[NgăANZXg[N擾
	if(NMailOAuth2GetAccessToken(GetTokenUri().c_str(), EditClientId->Text.c_str(), EditClientSecret->Text.c_str(), EditRefreshToken->Text.c_str(), NULL, NULL, json, TEMP_MAX, 0) == NMAIL_SUCCESS) {
		if((result = NMailJsonGetValue(json, _T("access_token"), token, TEMP_MAX, 0)) == NMAIL_SUCCESS) {
			EditAccessToken->Text = token;
			Clipboard()->AsText = EditAccessToken->Text;
		}
	}
	if(result != NMAIL_SUCCESS) {
		MessageDlg(_T("ANZXg[N̎擾Ɏs܂B"), mtError, TMsgDlgButtons() << mbOK, 0);
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonReceiveClick(TObject *Sender)
{
	if(EditMailAddress->Text == "") {
		MessageDlg(_T("[AhX͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditAccessToken->Text == "") {
		MessageDlg(_T("ANZXg[N擾ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(MessageDlg(_T("[M܂H"), mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
		TCHAR header[HEADER_MAX], subject[HEADER_MAX], date[HEADER_MAX], from[HEADER_MAX];
		TCHAR body[BODY_MAX];
		SOCKET s;
		if((s = NMailPop3ConnectSsl(Pop3Host[ComboBoxService->ItemIndex], NMAIL_POP3_SSL_PORT, NMAIL_SSL_TLS1, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			int no;
			if((no = NMailPop3AuthenticateMode(s, EditMailAddress->Text.c_str(), EditAccessToken->Text.c_str(), NMAIL_POP3_AUTH_OAUTH2)) >= 0) {
				int mail_no = _ttoi(EditNo->Text.c_str());
				if(mail_no <= no) {
					if(NMailPop3GetMail(s, mail_no, subject, date, from, header, body, NULL, NULL) == NMAIL_SUCCESS) {
						EditSubject->Text = subject;
						EditTo->Text = from;
						MemoBody->Lines->Text = body;
						SubjectReceived = subject;
						FromReceived = from;
						error_flag = false;
					}
				} else {
					MessageDlg(_T("w̔ԍ̃[݂܂B"), mtError, TMsgDlgButtons() << mbOK, 0);
					error_flag = false;
				}
			}
			if(error_flag) {
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
				MessageDlg(header, mtError, TMsgDlgButtons() << mbOK, 0);
			}
			NMailPop3Close(s);
		} else {
			MessageDlg(_T("ڑG["), mtError, TMsgDlgButtons() << mbOK, 0);
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonSendClick(TObject *Sender)
{
	if(EditMailAddress->Text == "") {
		MessageDlg(_T("[AhX͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditAccessToken->Text == "") {
		MessageDlg(_T("ANZXg[N擾ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditTo->Text == "") {
		MessageDlg(_T("͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditSubject->Text == "") {
		MessageDlg(_T("͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(MemoBody->Lines->Text == "") {
		MessageDlg(_T("{͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditTo->Text == FromReceived && EditSubject->Text == SubjectReceived) {
		MessageDlg(_T("M[̂܂ܕԑĂ܂܂B\n⌏ύXĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(MessageDlg(_T("[𑗐M܂H"), mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
		SOCKET s;
		int port = NMAIL_SMTP_SSL_PORT;
		int ssl_mode = NMAIL_SSL_TLS1;
		if(ComboBoxService->ItemIndex == serviceOffice365) {
			port = NMAIL_SMTP_SUBMISSION_PORT;
			ssl_mode |= NMAIL_SSL_STARTTLS;
		}
		if((s = NMailSmtpConnectSsl(SmtpHost[ComboBoxService->ItemIndex], port, ssl_mode, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			if(NMailSmtpAuthenticate(s, SmtpHost[ComboBoxService->ItemIndex], EditMailAddress->Text.c_str(), EditAccessToken->Text.c_str(), NMAIL_SMTP_AUTH_OAUTH2) == NMAIL_SUCCESS) {
				if(NMailSmtpSendMailEx(s, EditTo->Text.c_str(), NULL, NULL, EditMailAddress->Text.c_str(), EditSubject->Text.c_str(), MemoBody->Lines->Text.c_str(), NULL, NULL, NULL, 0) == NMAIL_SUCCESS) {
			        MessageDlg(_T("M܂B"), mtInformation, TMsgDlgButtons() << mbOK, 0);
			        error_flag = false;
				}
			}
			if(error_flag) {
				TCHAR msg[HEADER_MAX];
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, msg, HEADER_MAX);
				MessageDlg(msg, mtError, TMsgDlgButtons() << mbOK, 0);
			}
		} else {
			MessageDlg(_T("ڑG["), mtError, TMsgDlgButtons() << mbOK, 0);
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::ButtonReceiveImap4Click(TObject *Sender)
{
	if(EditMailAddress->Text == "") {
		MessageDlg(_T("[AhX͂ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(EditAccessToken->Text == "") {
		MessageDlg(_T("ANZXg[N擾ĂB"), mtError, TMsgDlgButtons() << mbOK, 0);
		return;
	}
	if(MessageDlg(_T("[M܂H"), mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
		TCHAR header[HEADER_MAX], subject[HEADER_MAX], date[HEADER_MAX], from[HEADER_MAX];
		TCHAR body[BODY_MAX];
		SOCKET s;
		if((s = NMailImap4ConnectSsl(Imap4Host[ComboBoxService->ItemIndex], NMAIL_IMAP4_SSL_PORT, NMAIL_SSL_TLS1, NULL)) != INVALID_SOCKET) {
			bool error_flag = true;
			if(NMailImap4Authenticate(s, EditMailAddress->Text.c_str(), EditAccessToken->Text.c_str(), NMAIL_IMAP4_AUTH_OAUTH2) == NMAIL_SUCCESS) {
				if(NMailImap4SelectMailBox(s, EditMailBox->Text.c_str(), FALSE) >= 0) {
					int count;
					if((count = NMailImap4SearchMail(s, NMAIL_IMAP4_SEARCH_UNDELETED, NULL, NMAIL_IMAP4_USE_UID)) > 0) {
						int mail_no = _ttoi(EditNo->Text.c_str());
						if(mail_no <= count) {
							DWORD uid;
							NMailImap4GetSearchMailResult(s, mail_no - 1, &uid);
							if(NMailImap4GetMail(s, uid, subject, date, from, header, body, NULL, NULL, NMAIL_IMAP4_USE_UID) == NMAIL_SUCCESS) {
								EditSubject->Text = subject;
								EditTo->Text = from;
								MemoBody->Lines->Text = body;
								SubjectReceived = subject;
								FromReceived = from;
								error_flag = false;
							}
						} else {
							MessageDlg(_T("w̔ԍ̃[݂܂B"), mtError, TMsgDlgButtons() << mbOK, 0);
							error_flag = false;
						}
					}
				}
			}
			if(error_flag) {
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, header, HEADER_MAX);
				MessageDlg(header, mtError, TMsgDlgButtons() << mbOK, 0);
			}
			NMailImap4Close(s);
		} else {
			MessageDlg(_T("ڑG["), mtError, TMsgDlgButtons() << mbOK, 0);
		}
	}
}
//---------------------------------------------------------------------------

